import numpy as np
from scipy.special import erfc, erf

#To get the number of ELG central
def CEN_Skew_normal(args,Mhalo):
   #,LMcut=11.5,sigma=0.2,gamma=3.0,kappa=0.1,pmax=0.2):
   #skew normal distribution from https://en.wikipedia.org/wiki/Skew_normal_distribution

   LMhalo=np.log10(Mhalo)
   #normal distribution
   #normdist=(1.0/np.sqrt(2.0*np.pi))
   normdist=np.exp(-np.power((LMhalo-args['LMcut'])/args['sigma'],2)/np.sqrt(2.0))
   cdfnorm=(1.0+erf(args['gamma']*(LMhalo-args['LMcut'])/(args['sigma']*np.sqrt(2.0))))

   #sharp step function to limit high mass probability
   #step_func=kappa*0.5*(1+np.sign(xx-(mu+sigma)))

   #smooth step function to limit high mass probability
   step_func=args['kappa']*0.5*(1+erf((LMhalo-args['LMcut'])/0.01))

   skewnorm=2.0*normdist*cdfnorm
   #find its maximum value
   max_val=np.max(skewnorm)
   #normalize to pmax
   skewnorm=(args['pmax']-args['kappa'])*skewnorm/max_val

   #Now add the step function to saturate the high mass end
   skewnorm=skewnorm+step_func

   #print(pmax,np.max(skewnorm))
   if(0):
      pl.plot(Mhalo,normdist,'k-')
      #pl.plot(xx,cdfnorm,'--')
   return skewnorm

#To get the number of ELG sattelite
def Sat_PowerLaw(args,Mhalo):
   #,LM1=12.0,alpha=1.0):
   Mdiff=np.log10(Mhalo)-args['LM1']

   Nsat=np.zeros(Mdiff.size)
   index=Mdiff>0
   #Nsat[index]=np.power(Mdiff[index],args['alpha'])
   Nsat[index]=np.power(10.0,Mdiff[index]*args['alpha'])

   return Nsat

#To get the number of ELG sattelite with using LMcut relation
def Sat_PowerLawLMcut(args,Mhalo):
   Mdiff=(Mhalo-np.power(10,args['LMcut']))/np.power(10,args['LM1'])
   Nsat=np.zeros(Mdiff.size)
   index=Mdiff>0
   Nsat[index]=np.power(Mdiff[index],args['alpha'])

   return Nsat



